
#include <iostream>
#include <string.h>
#include <stdio.h>
#include <stdlib.h>

#include <stdio.h>
#include <sys/types.h>
#include <dirent.h>
#include <vector>

using namespace std;

typedef struct tile {
	char data [8*8*3];
} tile;

bool tile_compare(const char * a, const char * b) {
	for (int i = 0; i < 64*3; i++) if (a[i] != b[i]) return false;
	return true;
}

void bmp_info(string file) {
	FILE * pFile = fopen (&file[0],"rb");

	char header[10];
	fread (&header,1,10,pFile);   //HEAD

	int pos_start;
	fread (&pos_start,4,1,pFile);   //read the pointer to the first pixel

	int width, height;
	fread (&width,1,4,pFile);    // width / height
	fread (&width,1,4,pFile);
	fread (&height,1,4,pFile);
	short bpp;
	fread (&bpp,1,2,pFile);         //2 clipplanes + bpp (2)
	fread (&bpp,1,2,pFile);

	fclose (pFile);

	pFile = fopen(&file[0],"rb");

	char remain[pos_start];
	fread (&remain,1,pos_start,pFile);   //skip all the head & stuff

	int buffer_size = width*height*bpp/8, counter = 0;
	unsigned char ibuffer[width*height*bpp/8];
	unsigned short obuffer[width*height];
	unsigned short obuffer2[width*height];
	fread (&ibuffer,1,buffer_size,pFile);

	//reconvert the image to 16bpp first.
	for (int i = 0; i <  buffer_size; i=i+(bpp/8)) 
		obuffer[counter++] = (ibuffer[i+0] >> 3) | ((ibuffer[i+1] >> 3) << 5) | ((ibuffer[i+2] >> 3) << 10);

	int k = 0;
	for (int i = height-1; i >= 0; i--) {
		memcpy(&obuffer2[k*width],&obuffer[i*width],width*2);  //the file
		k++;
	}

	//collect all the colors of the image and add them to the palette
	unsigned short palette[256];
	int num_colors = 1;   //the first olor is transparent!
	unsigned char indexed_image[width*height];

	for (int i = 0; i < counter; i++) {
		//look up the color, is it already in the list?
		bool listed = false;
		int index = 0;
		for (int j = 1; j < num_colors; j++) {
			if (obuffer2[i] == palette[j]) {
				listed = true;
				index = j;
				break;
			}
		}
		if (not listed) {
			palette[num_colors] = obuffer2[i];
			index = num_colors;
			num_colors++;
		}
		indexed_image[i] = index;
	}

	fclose (pFile);

//	1020   filename
//	4      filesize

	//print some info
	int j=0;
	for (j = file.size() -1 ; j >= 0; j--) if (file[j] == '/') break;
	int start = j+1; if (j == 0 and file[0] != '/') start = 0;
	int name_len = file.size()-start +1;

	cout << &file[start] << "   " << num_colors -1 << " colors" << endl;

}

void bmp_tile(string file) {
	FILE * pFile = fopen (&file[0],"rb");

	char header[10];
	fread (&header,1,10,pFile);   //HEAD

	int pos_start;
	fread (&pos_start,4,1,pFile);   //read the pointer to the first pixel

	int width, height;
	fread (&width,1,4,pFile);    // width / height
	fread (&width,1,4,pFile);
	fread (&height,1,4,pFile);
	short bpp;
	fread (&bpp,1,2,pFile);         //2 clipplanes + bpp (2)
	fread (&bpp,1,2,pFile);

	fclose (pFile);

	pFile = fopen(&file[0],"rb");

	char remain[pos_start];
	fread (&remain,1,pos_start,pFile);   //skip all the head & stuff

	int buffer_size = width*height*bpp/8, counter = 0;
	unsigned char ibuffer[width*height*bpp/8];
	fread (&ibuffer,1,buffer_size,pFile);

	int num_tiles = width*height/64;
	tile atile;
	vector <tile> tilelist(num_tiles);
	counter = 0;
	int twidth = width/8;
	int theight = height/8;
	
	for (int i = 0; i < twidth; i++) {
		for (int j = 0; j < theight; j++) {
			for (int k = 0; k < 8; k++) {
				memcpy (&atile.data[8*3*k],&ibuffer[(i*8+j*width*8+k*width)*3],8*3);
			}
			memcpy(&tilelist[counter].data[0],&atile.data[0],8*8*3);
			counter ++;
		}
	}

	//search for the unique tiles by copying them to a new list
	vector <tile> tilelist2(num_tiles);
	int num_tiles2 = 0;
	for (int i = 0; i < num_tiles; i++) {
		bool found = false;
		for (int j = 0; j < num_tiles2; j++) {
			if (tile_compare(&tilelist[i].data[0],&tilelist2[j].data[0])) {
				found = true;
				break;
			}
		}
		if (not found) {	//add to list
			memcpy (&tilelist2[num_tiles2].data[0],&tilelist[i].data[0],64*3);
			num_tiles2++;
		}
	}

	cout << "Num unique 8x8 tiles: " << num_tiles2 << " which waste about " << num_tiles2*32 << " bytes at 4bpp" << endl;
}

int main () {
	int rom_max_size = 128*1024;


	DIR *dp;
	struct dirent *ep;

	dp = opendir ("./data/");
	if (dp != NULL) {
		while (ep = readdir (dp)) {
			string object (ep->d_name);
			if (object != ".." && object != ".") {
				if (object.substr(object.size()-3) == "bmp") {
					bmp_info("./data/" + object);
					bmp_tile("./data/" + object);
				}
			}
		}
		(void) closedir (dp);
	}
     
       return 0;
}

