
#include <iostream>
#include <string.h>
#include <stdio.h>
#include <stdlib.h>

#include <stdio.h>
#include <sys/types.h>
#include <dirent.h>

using namespace std;

//make_sprite input output num_sprites colordepth transparent_color

//GBA uses BGR color!!!
int f_24to16 (int color) {
	int red = color >> 16;
	int green = (color >> 8) & 0xFF;
	int blue = color & 0xFF;
	return ((red >> 3)<< 0) | ((green >> 3) << 5) | ((blue >> 3) << 10);
}

void sprite_to_8x8_tiles (unsigned char * input, unsigned char * output, int size) {
	int num = size / 8;
	int count = 0;
	unsigned char tile [64];
	for (int i = 0; i < num; i++) {
		for (int j = 0; j < num; j++) {
			for (int k = 0; k < 8; k++) {
				memcpy(&tile[8*k], &input[size*8*i+8*j+size*k],8);
			}
			memcpy(&output[count],&tile[0],64);
			count = count + 64;
		}
	}
}

int main (int argc, const char *argv[]) {
	string input(argv[1]), output(argv[2]);
	int num_sprites = atoi(argv[3]);
	int color_depth = atoi(argv[4]);
	int trans_color = atoi(argv[5]); trans_color = f_24to16(trans_color);

	FILE * pFile = fopen (&input[0],"rb");

	char header[10];
	fread (&header,1,10,pFile);   //HEAD

	int pos_start;
	fread (&pos_start,4,1,pFile);   //read the pointer to the first pixel

	int width, height;
	fread (&width,1,4,pFile);    // width / height
	fread (&width,1,4,pFile);
	fread (&height,1,4,pFile);
	short bpp;
	fread (&bpp,1,2,pFile);         //2 clipplanes + bpp (2)
	fread (&bpp,1,2,pFile);

	fclose (pFile);

	pFile = fopen(&input[0],"rb");

	char remain[pos_start];
	fread (&remain,1,pos_start,pFile);   //skip all the head & stuff

	int buffer_size = width*height*bpp/8, counter = 0;
	unsigned char ibuffer[width*height*bpp/8];
	unsigned short obuffer[width*height];
	unsigned short obuffer2[width*height];
	fread (&ibuffer,1,buffer_size,pFile);
	
	for (int i = 0; i <  buffer_size; i=i+(bpp/8)) 
		obuffer[counter++] = (ibuffer[i+2] >> 3) | ((ibuffer[i+1] >> 3) << 5) | ((ibuffer[i+0] >> 3) << 10);

	fclose (pFile);

	int k = 0;
	for (int i = height-1; i >= 0; i--) {
		memcpy(&obuffer2[k*width],&obuffer[i*width],width*2);  //the file
		k++;
	}

	pFile = fopen (&output[0],"w");

	int h=0;
	for (h = output.size() -1 ; h >= 0; h--) if (output[h] == '/') break;
	int start = h+1; if (h == 0 and output[0] != '/') start = 0;
	int name_len = output.size()-start +1;

	char thefn[1020]; memset(&thefn[0],'\0',1020);
	memcpy (&thefn[0],&output[start],output.size()-start);
	fwrite(&thefn[0],1,1020,pFile);   // the null terminated string of the filename


	if (color_depth==256) {
		int counter2 = width * height + 512;
		fwrite(&counter2,1,4,pFile);  //file size

		unsigned short palette[256];
		int num_colors = 1;   //the first olor is transparent!
		unsigned char indexed_image[width*height];
		
		for (int i = 0; i < counter; i++) {
			if (trans_color == obuffer2[i]) {
				indexed_image[i] = 0;
			}else{
				//look up the color, is it already in the list?
				bool listed = false;
				int index = 0;
				for (int j = 1; j < num_colors; j++) {
					if (obuffer2[i] == palette[j]) {
						listed = true;
						index = j;
						break;
					}
				}
				if (not listed) {
					palette[num_colors] = obuffer2[i];
					index = num_colors;
					num_colors++;
				}
				indexed_image[i] = index;
			}
		}

		cout << num_colors << " colors found!" << endl;
		cout << num_sprites << " sprites found!" << endl;

		fwrite(&palette[0],1,512,pFile);
		
		for (int i = 0; i < num_sprites; i++) {
			unsigned char block_image[height*height];
			unsigned char image_chunks[height*height];
			for (int j = 0; j < height; j++) {
				memcpy(&block_image[j*height],&indexed_image[i*height + j*width],height);
			}
			sprite_to_8x8_tiles (&block_image[0],&image_chunks[0],height);
			fwrite(&image_chunks[0],1,height*height,pFile);
		}
	}else if (color_depth==16) {
		int counter2 = width * height / 2 + 32;
		fwrite(&counter2,1,4,pFile);  //file size

		unsigned short palette[16];
		int num_colors = 1;   //the first olor is transparent!
		unsigned char indexed_image[width*height];
		
		for (int i = 0; i < counter; i++) {
			if (trans_color == obuffer2[i]) {
				indexed_image[i] = 0;
			}else{
				//look up the color, is it already in the list?
				bool listed = false;
				int index = 0;
				for (int j = 1; j < num_colors; j++) {
					if (obuffer2[i] == palette[j]) {
						listed = true;
						index = j;
						break;
					}
				}
				if (not listed) {
					palette[num_colors] = obuffer2[i];
					index = num_colors;
					num_colors++;
				}
				indexed_image[i] = index;
			}
		}

		cout << num_colors << " colors found!" << endl;
		cout << num_sprites << " sprites found!" << endl;

		fwrite(&palette[0],1,32,pFile);
		
		for (int i = 0; i < num_sprites; i++) {
			unsigned char block_image[height*height];
			unsigned char image_chunks[height*height];
			for (int j = 0; j < height; j++) {
				memcpy(&block_image[j*height],&indexed_image[i*height + j*width],height);
			}
			sprite_to_8x8_tiles (&block_image[0],&image_chunks[0],height);
			unsigned char image_4bpp[height*height/2];
			for (int j = 0; j < (height*height); j=j+2) {
				image_4bpp[j/2] = ((image_chunks[j] & 0xF) << 4) | (image_chunks[j+1] & 0xF);
			}
			fwrite(&image_4bpp[0],1,height*height/2,pFile);
		}
	}

	fclose (pFile);

}

