
//// INIT FUNC (LOGO, ETC) /////

#include "gba_types.h"
#include "gba_mem.h"
#include "gba_const.h"
#include <stdlib.h>
#include <stdio.h>
#include <string.h>
#include "aux.h"
#include "data_read.h"

void ColorScreen(u16 color) {
	u16 * frame = VIDEO_BUFFER;
	DISPLAY_CONTROL=MODE3 | BACKGROUND2;
	
	memset(frame,color,240*160*2);
	vsync ();
}

void PrintLogo () {
	int i,j;

	u8 * palette_rom = (u8*)GetFilePointer("logo.pal.bmp");
	u16 * bitmap = (u16*)&palette_rom[512];

	DISPLAY_CONTROL=MODE4 | BACKGROUND2;
	memcpy ((u16*)VIDEO_BUFFER,bitmap,240*160);
	memcpy ((u8*)BACKGROUND_PALETTE,palette_rom,512);

	for (i = 0; i < 120; i++) {vsync ();} //2 seconds  (60fps)

	u16 * palette = BACKGROUND_PALETTE;

	for (j = 0; j < 200; j ++) {
	for (i = 0; i < 256; i++) {
		u32 red = 31 * (palette[i] >> 10) >> 5;
		u32 green = 31 * ((palette[i] >> 5) & 0x1F) >> 5;
		u32 blue = 31 * (palette[i] & 0x1F) >> 5;
		palette[i] = (red << 10) | (green << 5) | blue;
	}
	
	vsync ();
	}
}
