
#include "gba_types.h"
#include "gba_mem.h"
#include "gba_const.h"

#include <stdlib.h>
#include <stdio.h>
#include <string.h>


#ifndef LEVEL_LOADER
#define LEVEL_LOADER

typedef struct VIEWPORT {
	s32 x,y,xmin,xmax,ymin,ymax;
} VIEWPORT;

typedef struct tlevel {
	u32 width, height;
	u32 width32, height32;

	u16 * level_buffer_screenblock;
	u16 * screenblock;
	u8 * collision;
}tlevel;

void LoadLevel(u8 * level_data, u8 * screenblock, u8 * collision, tlevel * level);
void LoadTileset (u8 * tileset, u8 * charblock);

void SetCharacterPos(u32 x, u32 y, tlevel * level);
inline void bgs_copy_row (u16 * datap, u16 * sb,u32 mapwidth, u32 x, u32 y);
inline void bgs_copy_col (u16 * datap, u16 * sb,u32 mapwidth, u32 x, u32 y);
inline void ViewportAdjust (u32 mapwidth, u32 mapheight);
void BGScroll(u16 * datap, u16 * sb, u32 mapwidth, u32 mapheight);
inline void ViewportCenter (u32 x, u32 y);
void Copy64x64 (tlevel * level);


#endif


