
#include <iostream>
#include <string.h>
#include <stdio.h>
#include <stdlib.h>

#include <stdio.h>
#include <sys/types.h>
#include <dirent.h>

using namespace std;

void pack_bmp(string file, FILE * output) {
	FILE * pFile = fopen (&file[0],"rb");

	char header[10];
	fread (&header,1,10,pFile);   //HEAD

	int pos_start;
	fread (&pos_start,4,1,pFile);   //read the pointer to the first pixel

	int width, height;
	fread (&width,1,4,pFile);    // width / height
	fread (&width,1,4,pFile);
	fread (&height,1,4,pFile);
	short bpp;
	fread (&bpp,1,2,pFile);         //2 clipplanes + bpp (2)
	fread (&bpp,1,2,pFile);

	fclose (pFile);

	pFile = fopen(&file[0],"rb");

	char remain[pos_start];
	fread (&remain,1,pos_start,pFile);   //skip all the head & stuff

	int buffer_size = width*height*bpp/8, counter = 0;
	unsigned char ibuffer[width*height*bpp/8];
	unsigned short obuffer[width*height];
	fread (&ibuffer,1,buffer_size,pFile);
	for (int i = 0; i <  buffer_size; i=i+(bpp/8)) 
		obuffer[counter++] = (ibuffer[i+2] >> 3) | ((ibuffer[i+1] >> 3) << 5) | ((ibuffer[i+0] >> 3) << 10);

	fclose (pFile);

//	1020   filename
//	4      filesize

	//print some info
	int j=0;
	for (j = file.size() -1 ; j >= 0; j--) if (file[j] == '/') break;
	int start = j+1; if (j == 0 and file[0] != '/') start = 0;
	int name_len = file.size()-start +1;

	char thefn[1020]; memset(&thefn[0],'\0',1020);
	memcpy (&thefn[0],&file[start],file.size()-start);
	fwrite(&thefn[0],1,1020,output);   // the null terminated string of the filename
	int counter2 = counter * 2;
	fwrite(&counter2,1,4,output);  //file size

	for (int i = height-1; i >= 0; i--) {
		fwrite(&obuffer[i*width],1,width*2,output);  //the file
	}
}

void pack_bmp_pal(string file, FILE * output) {
	FILE * pFile = fopen (&file[0],"rb");

	char header[10];
	fread (&header,1,10,pFile);   //HEAD

	int pos_start;
	fread (&pos_start,4,1,pFile);   //read the pointer to the first pixel

	int width, height;
	fread (&width,1,4,pFile);    // width / height
	fread (&width,1,4,pFile);
	fread (&height,1,4,pFile);
	short bpp;
	fread (&bpp,1,2,pFile);         //2 clipplanes + bpp (2)
	fread (&bpp,1,2,pFile);

	fclose (pFile);

	pFile = fopen(&file[0],"rb");

	char remain[pos_start];
	fread (&remain,1,pos_start,pFile);   //skip all the head & stuff

	int buffer_size = width*height*bpp/8, counter = 0;
	unsigned char ibuffer[width*height*bpp/8];
	unsigned short obuffer[width*height];
	unsigned short obuffer2[width*height];
	fread (&ibuffer,1,buffer_size,pFile);

	//reconvert the image to 16bpp first.
	for (int i = 0; i <  buffer_size; i=i+(bpp/8)) 
		obuffer[counter++] = (ibuffer[i+2] >> 3) | ((ibuffer[i+1] >> 3) << 5) | ((ibuffer[i+0] >> 3) << 10);

	int k = 0;
	for (int i = height-1; i >= 0; i--) {
		memcpy(&obuffer2[k*width],&obuffer[i*width],width*2);  //the file
		k++;
	}

	//collect all the colors of the image and add them to the palette
	unsigned short palette[256];
	int num_colors = 1;   //the first olor is transparent!
	unsigned char indexed_image[width*height];

	for (int i = 0; i < counter; i++) {
		//look up the color, is it already in the list?
		bool listed = false;
		int index = 0;
		for (int j = 1; j < num_colors; j++) {
			if (obuffer2[i] == palette[j]) {
				listed = true;
				index = j;
				break;
			}
		}
		if (not listed) {
			palette[num_colors] = obuffer2[i];
			index = num_colors;
			num_colors++;
		}
		indexed_image[i] = index;
	}

	fclose (pFile);

//	1020   filename
//	4      filesize

	//print some info
	int j=0;
	for (j = file.size() -1 ; j >= 0; j--) if (file[j] == '/') break;
	int start = j+1; if (j == 0 and file[0] != '/') start = 0;
	int name_len = file.size()-start +1;

	char thefn[1020]; memset(&thefn[0],'\0',1020);
	memcpy (&thefn[0],&file[start],file.size()-start);
	fwrite(&thefn[0],1,1020,output);   // the null terminated string of the filename
	int counter2 = width * height + 512;
	fwrite(&counter2,1,4,output);  //file size

	//write palette
	fwrite(&palette[0],1,512,output);

	fwrite(&indexed_image[0],1,width*height,output);
}


void pack_copy (string file, FILE * output) {
	FILE * pFile = fopen(&file[0],"rb");
	fseek(pFile,0,SEEK_END);
	int file_size = ftell(pFile);
	fseek(pFile,0,SEEK_SET);
	char buf[file_size];
	fread(&buf[0],1,file_size,pFile);
	fclose(pFile);
	fwrite(&buf[0],1,file_size,output);
	cout << file << " added!" << endl;
}

void pack_data (string file, FILE * output) {
	//print some info
	int j=0;
	for (j = file.size() -1 ; j >= 0; j--) if (file[j] == '/') break;
	int start = j+1; if (j == 0 and file[0] != '/') start = 0;
	int name_len = file.size()-start +1;

	char thefn[1020]; memset(&thefn[0],'\0',1020);
	memcpy (&thefn[0],&file[start],file.size()-start);
	fwrite(&thefn[0],1,1020,output);   // the null terminated string of the filename


	FILE * pFile = fopen(&file[0],"rb");
	fseek(pFile,0,SEEK_END);
	int file_size = ftell(pFile);
	fseek(pFile,0,SEEK_SET);
	char buf[file_size];
	fread(&buf[0],1,file_size,pFile);
	fclose(pFile);
	fwrite(&file_size,1,4,output);  //file size
	fwrite(&buf[0],1,file_size,output);
	cout << file << " added!" << endl;
}



int main (int argc, const char *argv[]) {
	string input(argv[1]), output(argv[2]);
	int rom_max_size = 1024 * atoi(argv[3]); // 16*1024;  SIZE IN KB

	FILE * Out = fopen(&output[0],"w");

	FILE * In = fopen(&input[0],"rb");
	fseek(In,0,SEEK_END);
	int rom_size = ftell(In);
	fseek(In,0,SEEK_SET);
	char buffer[rom_size];
	fread (&buffer[0],1,rom_size,In);
	fwrite(&buffer[0],1,rom_size,Out);
	char ebuf[rom_max_size - rom_size];
	memset(&ebuf[0],'\0',rom_max_size - rom_size);
	fwrite(&ebuf[0],1,rom_max_size - rom_size,Out);
	fclose (In);

	DIR *dp;
	struct dirent *ep;

	dp = opendir ("./data/");
	if (dp != NULL) {
		while (ep = readdir (dp)) {
			string object (ep->d_name);
			if (object != ".." && object != ".") {
				if (object.substr(object.size()-7) == "pal.bmp") pack_bmp_pal("./data/" + object,Out);
				//else if (object.substr(object.size()-3) == "bmp") pack_bmp("./data/" + object,Out);
				else if (object.substr(object.size()-9) == "collision") pack_data("./data/" + object,Out);
				else if (object.substr(object.size()-7) == "tileset") pack_data("./data/" + object,Out);
				else if (object.substr(object.size()-6) == "sprite") pack_copy("./data/" + object,Out);
				//else if (object.substr(object.size()-5) == "level") pack_copy("./data/" + object,Out);
				else if (object.substr(object.size()-5) == "level") pack_data("./data/" + object,Out);
			}
		}
		(void) closedir (dp);
	}

	fclose(Out);

       return 0;
}

