
#include <iostream>
#include <string.h>
#include <stdio.h>
#include <stdlib.h>

#include <stdio.h>
#include <sys/types.h>
#include <dirent.h>
#include <vector>

using namespace std;

typedef struct tile {
	unsigned char data [8*8];
} tile;

bool tile_compare(const unsigned char * a, const unsigned char * b) {
	for (int i = 0; i < 64; i++) if (a[i] != b[i]) return false;
	return true;
}

void fliph(const unsigned char * a, unsigned char * b) {
	for (int i = 0; i < 8; i++) {
		for (int j = 0; j < 8; j++) {
			b[8*j+8-i-1] = a[8*j+i];
		}
	}
}

void flipv(const unsigned char * a, unsigned char * b) {
	for (int i = 0; i < 8; i++) {
		for (int j = 0; j < 8; j++) {
			b[j+(8-i-1)*8] = a[j+i*8];
		}
	}
}


//GBA uses BGR!!!!!!!!!
int f_24to16 (int color) {
	int red = color >> 16;
	int green = (color >> 8) & 0xFF;
	int blue = color & 0xFF;
	return ((red >> 3)<< 0) | ((green >> 3) << 5) | ((blue >> 3) <<10);
}

////////// LEVEL / BG
// u32 width, height                    : 8 bytes
// each tile index 2 bytes

int main (int argc, const char *argv[]) {
	//tile_tool   input.bmp   input.tileset    output.level    
	string input(argv[1]), input2(argv[2]), output(argv[3]);
	//int trans_color = atoi(argv[3]); trans_color = f_24to16(trans_color);

	//READ THE TILESET FILE
	FILE * pFile3 = fopen (&input2[0],"rb");
	if (pFile3 == NULL) { cout << "Cannot open input file: " << input2 << endl; return 0; }
	fseek(pFile3, 0, SEEK_END);
	int fis2 = ftell(pFile3);
	fseek(pFile3, 0, SEEK_SET);
	char * inputbuffer2 = new char [fis2];
	fread(&inputbuffer2[0],1,fis2,pFile3);
	fclose (pFile3);
	unsigned short palette[256];
	memcpy (&palette[0],&inputbuffer2[0],512);
	int numtiles_tileset = *(int*)&inputbuffer2[512];
	unsigned char * or_tileset = (unsigned char*)&inputbuffer2[1024];
	

	/// READ THE INPUT BMP FILE
	FILE * pFile = fopen (&input[0],"rb");
	if (pFile == NULL) { cout << "Cannot open input file: " << input << endl; return 0; }
	fseek(pFile, 0, SEEK_END);
	int fis = ftell(pFile);
	fseek(pFile, 0, SEEK_SET);
	char * inputbuffer = new char [fis];
	fread(&inputbuffer[0],1,fis,pFile);
	fclose (pFile);

	short bpp;
	int width, height;
	width = *(int *)&inputbuffer[18];
	height = *(int *)&inputbuffer[22];
	bpp = *(short *)&inputbuffer[28];

	cout << "The bitmap is " << width << "x" << height << " and " << bpp << "bpp" << endl;
	if (width % 8 != 0 or height % 8 != 0) {cout << "The image dimensions are not multiple of 8!" << endl; return 0;}

	int counter =0;
	unsigned char * ibuffer = (unsigned char *)&inputbuffer[*(int*)&inputbuffer[10]];  //Pointer to the input data
	unsigned short * obuffer =  new unsigned short [width*height];  //Pointer to a new buffer 16 bit color
	unsigned short * obuffer2 =  new unsigned short [width*height];  //Pointer to a new buffer 16 bit color (flip)
	unsigned char * obuffer3 = new unsigned char [width*height];  //The buffer with the indexed color image

	for (int i = 0; i <  width*height*bpp/8; i=i+(bpp/8)) {
		obuffer[counter++] = (ibuffer[i+2] >> 3) | ((ibuffer[i+1] >> 3) << 5) | ((ibuffer[i+0] >> 3) << 10); }

	//We invert the lines, as the BMP is fliped vertically
	int k = 0;
	for (int i = height-1; i >= 0; i--) {
		memcpy(&obuffer2[k*width],&obuffer[i*width],width*2);  //the file
		k++;
	}
	delete [] obuffer;

	//Now we have to index the image but we use the palette in tileset
	for (int i = 0; i < counter; i++) {
		for (int j = 0; j < 256; j++) {
			if (obuffer2[i] == palette[j]) {
				obuffer3[i] = j;
				break;
			}
		}
	}

	delete [] obuffer2;

	//CREATE A LIST WITH ALL THE 8x8 TILES

	int num_tiles = width*height/64;
	tile atile;
	vector <tile> tilelist(num_tiles);
	counter = 0;
	int twidth = width/8;
	int theight = height/8;
	
	for (int j = 0; j < theight; j++) {
		for (int i = 0; i < twidth; i++) {
			for (int k = 0; k < 8; k++) {
				memcpy (&atile.data[8*k],&obuffer3[i*8+j*width*8+k*width],8);
			}
			memcpy(&tilelist[counter].data[0],&atile.data[0],8*8);
			counter ++;
		}
	}
	delete [] obuffer3;

	//NOW INDEX THE TILES
	unsigned short indexed[num_tiles];  //The output
	tile temp;
	for (int i = 0; i < num_tiles; i++) {
		bool found = false;
		for (int j = 0; j < numtiles_tileset; j++) {
			if (tile_compare(&tilelist[i].data[0],&or_tileset[j*64]) ) {
				indexed[i] = j;
				found = true;
				break;
			}
			fliph(&tilelist[i].data[0],&temp.data[0]);
			if (tile_compare(&temp.data[0],&or_tileset[j*64])) {   //fliped H
				indexed[i] = j | 1 << 10;
				found = true;
				break;
			}
			flipv(&tilelist[i].data[0],&temp.data[0]);
			if (tile_compare(&temp.data[0],&or_tileset[j*64])) {   //fliped V
				indexed[i] = j | 1 << 11;
				found = true;
				break;
			}
			flipv(&tilelist[i].data[0],&temp.data[0]);
			fliph(&temp.data[0],&temp.data[0]);
			if (tile_compare(&temp.data[0],&or_tileset[j*64])) {   //fliped V & H
				indexed[i] = j | 1 << 11 | 1 << 10;
				found = true;
				break;
			}
		}
		if (not found) cout << "A tile was not found!" << endl;
	}

	
	//NOW WE ARE READY TO WRITE ALL THE OUTPUT FILE!
	FILE * pFile2 = fopen (&output[0],"w");
	unsigned int auxnum = width / 8;
	fwrite (&auxnum,1,4,pFile2);
	auxnum = height / 8;
	fwrite (&auxnum,1,4,pFile2);
	fwrite(&indexed[0],1,num_tiles*2,pFile2);
	fclose(pFile2);

	cout << "DONE" << endl;

	delete [] inputbuffer;
	delete [] inputbuffer2;
	return 0;
}



