

#include <string.h>
#include <math.h>

#include "gba_types.h"
#include "gba_const.h"
#include "gba_mem.h"

#include "trans.h"
#include "aux.h"

extern OAMEntry sprites[128];
extern pRotData rotData;
extern RotInfo rot_info;

//// TRANSFORM FUNCTIONS /////

inline void trans_identity (u32 n) {
	rotData[n].pa = 256;
	rotData[n].pb = 0;
	rotData[n].pc = 0;
	rotData[n].pd = 256;
}

inline void trans_identity_f (u32 n) {
	rotData[n].pa = -256;
	rotData[n].pb = 0;
	rotData[n].pc = 0;
	rotData[n].pd = 256;
}

inline void trans_rotate_45 (u32 n) {
	rotData[n].pa = 180;
	rotData[n].pb = 180;
	rotData[n].pc = -180;
	rotData[n].pd = 180;
}

inline void trans_rotate_45_f (u32 n) {
	rotData[n].pa = -180;
	rotData[n].pb = -180;
	rotData[n].pc = -180;
	rotData[n].pd = 180;
}

inline void trans_rotate_m45 (u32 n) {
	rotData[n].pa = 180;
	rotData[n].pb = -180;
	rotData[n].pc = 180;
	rotData[n].pd = 180;
}

inline void trans_rotate_m45_f (u32 n) {
	rotData[n].pa = -180;
	rotData[n].pb = 180;
	rotData[n].pc = 180;
	rotData[n].pd = 180;
}


inline void trans_rotate_15 (u32 n) {
	rotData[n].pa = 247;
	rotData[n].pb = 66;
	rotData[n].pc = -66;
	rotData[n].pd = 247;
}

inline void trans_rotate_15_f (u32 n) {
	rotData[n].pa = -247;
	rotData[n].pb = -66;
	rotData[n].pc = -66;
	rotData[n].pd = 247;
}


inline void trans_rotate_m15 (u32 n) {
	rotData[n].pa = 247;
	rotData[n].pb = -66;
	rotData[n].pc = 66;
	rotData[n].pd = 247;
}

inline void trans_rotate_m15_f (u32 n) {
	rotData[n].pa = -247;
	rotData[n].pb = 66;
	rotData[n].pc = 66;
	rotData[n].pd = 247;
}


inline void trans_rotate_25 (u32 n) {
	rotData[n].pa = 232;
	rotData[n].pb = 108;
	rotData[n].pc = -108;
	rotData[n].pd = 232;
}

inline void trans_rotate_25_f (u32 n) {
	rotData[n].pa = -232;
	rotData[n].pb = -108;
	rotData[n].pc = -108;
	rotData[n].pd = 232;
}

inline void trans_rotate_m25 (u32 n) {
	rotData[n].pa = 232;
	rotData[n].pb = -108;
	rotData[n].pc = 108;
	rotData[n].pd = 232;
}

inline void trans_rotate_m25_f (u32 n) {
	rotData[n].pa = -232;
	rotData[n].pb = 108;
	rotData[n].pc = 108;
	rotData[n].pd = 232;
}

void hide_all_sprites (void) {
	u32 i;
	for (i = 0; i < 128; i++) sprites[i].attribute0 = ATTRIB0_HID_SPRITE;

	vsync();

	u32 loop;
	u16* temp;
	temp = (u16*)sprites;
	for(loop = 0;loop < 128*4; loop++) {  //copy sprite info
		OAMmem[loop] = temp[loop];
	}
}


